#include "stringops.h"

bFLAG StringCompare(const char *string1, const char *string2)
{
	uLONG i;

	i = 0;
	while ((string1[i] == string2[i]) && (string1[i]) && (string2[i]))
	{
		i++;
	}

	return (string1[i] == string2[i]);
}

static uLONG ConvertHex(const char *string)
{
	uLONG i, val;
	char c;

	i = 0;
	val = 0;

	while (1) {
		c = string[i];
		if ((c >= '0') && (c <= '9')) {
			val <<= 4;
			val |= (c - '0');
		} else {
			if ((c >= 'a') && (c <= 'f')) {
				val <<= 4;
				val |= (c - 'a' + 10);
			} else {
				if ((c >= 'A') && (c <= 'F')) {
					val <<= 4;
					val |= (c - 'A' + 10);
				} else break;
			}
		}
		i++;
	}

	return val;
}

static uLONG ConvertDec(const char *string)
{
	uLONG i, val;
	char c;

	i = 0;
	val = 0;

	while (1) {
		c = string[i];
		if ((c >= '0') && (c <= '9')) {
			val *= 10;
			val += (c - '0');
		} else break;
		i++;
	}

	return val;
}

uLONG ConvertNumber(const char *string)
{
	uLONG i;

	if (!string) return 0;

	i = 0;
	while (string[i] == 0x20) i++;

	if (string[i] == '$') return ConvertHex(string+1);
	if ((string[i] == '0') && (string[i+1] == 'x')) return ConvertHex(string+2);

	return ConvertDec(string);
}
